package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.common.base.Preconditions;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.loot.AffixLootEntry;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import net.minecraft.resources.ResourceLocation;

public class AffixLootRegistry extends WeightedDynamicRegistry<AffixLootEntry> {
  public static final dev.shadowsoffire.apotheosis.adventure.loot.AffixLootRegistry INSTANCE = new dev.shadowsoffire.apotheosis.adventure.loot.AffixLootRegistry();
  
  private AffixLootRegistry() {
    super(AdventureModule.LOGGER, "affix_loot_entries", false, false);
  }
  
  protected void registerBuiltinCodecs() {
    registerDefaultCodec(Apotheosis.loc("affix_loot_entry"), AffixLootEntry.CODEC);
  }
  
  protected void validateItem(ResourceLocation key, AffixLootEntry item) {
    super.validateItem(key, (CodecProvider)item);
    Preconditions.checkArgument(!item.stack.m_41619_(), "Empty itemstacks are not permitted.");
    Preconditions.checkArgument(!item.getType().isNone(), "Items without a valid loot category are not permitted.");
    Preconditions.checkArgument((item.getMinRarity().ordinal() <= item.getMaxRarity().ordinal()), "The minimum rarity must be lower or equal to the max rarity.");
  }
}
